//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_SWINTCONTLED.h
//  Version: 1.1, Updated on 2008/6/23 at 14:9:22
//  `@PSOC_VERSION`
//
//  DESCRIPTION:  Header file for the SWINTCONTLED Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#ifndef `@LIB_NAME`_SWINTCONTLED_include
#define `@LIB_NAME`_SWINTCONTLED_include

#include <M8C.h>

`@SWINTCONTLED_ORDINAL_DEFINE_BLOCK`
#define `@LIB_NAME`_SWINTCONTLED_COUNT `@SWINTCONTLED_COUNT`
////////////////////////////////////////////////////////////////////////////////////////////

// parameter block
typedef struct
{	
	BYTE Mode;
    BYTE SWINTCONTLED_ChannelID;  // Instance ID

}`@LIB_NAME`_SWINTCONTLED_ParameterBlock;

// Function Prototypes
void `@LIB_NAME`_SWINTCONTLED_SetValue(const `@LIB_NAME`_SWINTCONTLED_ParameterBlock * thisBLK, BYTE bSWINTCONTLEDDutyCycle);
void `@LIB_NAME`_SWINTCONTLED_Instantiate(const `@LIB_NAME`_SWINTCONTLED_ParameterBlock * thisBLK);

#endif