//
//  SystemConst.h
//
//     Defines system constant structure

#ifndef SYSTEMCONST_H
#define SYSTEMCONST_H

#include "m8c.h"
#include "CMXSystemFunction.h"
#include "CMX_CSDRPROPERTYConst.h"

#include "CMX_CSDRSLIDERConst.h"

#include "CMX_CSDRSLIDERConst.h"


#define RESERVED_BLOCK_SIZE 2 // This is the number of bytes of flash reserved

typedef struct
{

	CSDProperties pse_CSDProp;

	CSDSliderSettings pse_Slide_X;

	CSDSliderSettings pse_Slide_Y;

	struct
	{
		char title[RESERVED_BLOCK_SIZE];
	} ReserveBlock;
} SYSTEM_CONSTANT_STRUC;

// overall count oF integer values contained in the constant structure
#define SYSTEM_CONST_COUNT 14

#endif
