﻿Public Class Form1
    Dim CurrentPort As String
    Dim Rdata, TmpS As String
    Dim X, Y As Integer
    Dim PX, PY As Integer
    Dim OX, OY As Integer
    Dim SX, SY As Integer
    Dim RStart As Integer
    Dim PenColor As System.Drawing.Pen

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CurrentPort = ""
        ComboBox1.Text = "COM1"
        For I As Integer = 1 To 20
            Rdata = I.ToString
            ComboBox1.Items.Add("COM" + Rdata)
        Next
        RStart = 0
        X = 0
        Y = 0
        OX = Panel1.Location.X
        OY = Panel1.Location.Y
        SX = Panel1.Size.Width
        SY = Panel1.Size.Height
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        If RStart = 1 Then
            PenColor = Pens.Red
        Else
            PenColor = Pens.Black
        End If
        PX = X * SX / 100 + OX
        PY = SY - Y * SY / 100 + OY
        e.Graphics.DrawRectangle(PenColor, OX, OY, SX, SY)
        e.Graphics.DrawRectangle(PenColor, PX - 5, PY - 5, 10, 10)
        e.Graphics.DrawLine(PenColor, PX - 5, PY - 5, PX + 5, PY + 5)
        e.Graphics.DrawLine(PenColor, PX + 5, PY - 5, PX - 5, PY + 5)
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        If RStart > 0 Then
            ComboBox1.Text = CurrentPort
        Else
            TextBox1.Text = ComboBox1.Text
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If RStart > 0 Then
            Exit Sub
        End If
        If CurrentPort <> "" Then
            SerialPort1.Close()
            CurrentPort = ""
        End If
        SerialPort1.PortName = ComboBox1.Text
        Try
            SerialPort1.Open()
        Catch ex As Exception
            TextBox1.Text = "COM?"
            Exit Sub
        End Try
        CurrentPort = ComboBox1.Text
        RStart = 1
        Refresh()
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If RStart <> 1 Then
            Exit Sub
        End If
        Try
            SerialPort1.WriteLine("RD 02")
            Rdata = SerialPort1.ReadLine
            If (Rdata.Length < 5) Then
                Rdata = SerialPort1.ReadLine
            End If
        Catch ex As Exception
            TextBox1.Text = "Read Line Error!"
            SerialPort1.Close()
            CurrentPort = ""
            RStart = 0
            Timer1.Stop()
            Refresh()
            Exit Sub
        End Try
        Try
            X = Val("&H" + Rdata.Substring(0, 2))
            Y = Val("&H" + Rdata.Substring(3, 2))
        Catch ex As Exception
            TextBox1.Text = "Read Data Error!"
            SerialPort1.Close()
            CurrentPort = ""
            RStart = 0
            Timer1.Stop()
            Refresh()
            Exit Sub
        End Try
        TmpS = Rdata
        Rdata = Str(X) + "  " : Rdata = Rdata.Substring(1, 3)
        TmpS = TmpS + " (" + Rdata
        Rdata = Str(Y) + "  " : Rdata = Rdata.Substring(1, 3)
        TmpS = TmpS + "," + Rdata + ")"
        TextBox1.Text = TmpS
        Refresh()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If RStart = 1 Then
            Timer1.Stop()
            RStart = 0
            SerialPort1.Close()
            CurrentPort = ""
            Refresh()
        End If
    End Sub
End Class
