//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_CSDRPROPERTY.h
//  Version: 1.0, Updated on 2009/5/7 at 21:17:42
//  `@PSOC_VERSION`
//
//  DESCRIPTION:  Header file for CSDRPROPERTY driver 
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef CSDRPROPERTY_INCLUDE
#define CSDRPROPERTY_INCLUDE

#include <M8C.h>
#include "CMX_CSDRPROPERTYConst.h"
`@CSDRPROPERTY_ORDINAL_DEFINE_BLOCK`
#define `@LIB_NAME`_CSDRPROPERTY_COUNT `@CSDRPROPERTY_COUNT`

////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
	const CSDProperties * pCSDProperties;
}`@LIB_NAME`_CSDRPROPERTY_ParameterBlock;

//-------------------------------------------------
// Prototypes of the CSDRPROPERTY API.
//-------------------------------------------------
extern void `@LIB_NAME`_CSDRPROPERTY_Instantiate(const `@LIB_NAME`_CSDRPROPERTY_ParameterBlock * pPBlock);

#endif
