//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_CSDRPROPERTYConst.h
//  Version: 1.0, Updated on 2009/5/7 at 21:17:42
//  `@PSOC_VERSION`
//
//  DESCRIPTION:  Header file for CSDRPROPERTY driver 
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef CSDRPROPERTYCONST_INCLUDE
#define CSDRPROPERTYCONST_INCLUDE

typedef struct
{
  const BYTE NoiseThreshold;
  const BYTE BaselineUpdateThreshold;
  const BYTE NegativeNoiseThreshold;
  const BYTE LowBaselineReset;
  const BYTE Hysteresis;
  const BYTE Debounce;
} CSDProperties;

#endif
